

import 'package:adjust_custom_test_alone_example/first_screen.dart';
import 'package:adjust_custom_test_alone_example/shared_pref.dart';
import 'package:adjust_custom_test_alone_example/utils.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

void main() {
  WidgetsFlutterBinding.ensureInitialized();
  runApp(MaterialApp(home: MyApp()));
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp>       {

  @override
  initState() {
    super.initState();
     _init();
   }

  @override
  Widget build(BuildContext context) {
    return FirstScreen();
  }

  String _baseUrl = 'Http://adtrace.io';
  String _appToken = 'assd123';

  Future<void> _init() async {
    List<String> urls =
        await ShpHelper.readStringList(StorageKeys.base_url_list_key);
    List<String> tokens =
        await ShpHelper.readStringList(StorageKeys.app_tokens_list_key);
    if (!(isValueStringListOk(urls) && isValueStringListOk(tokens))) {
      urls = [];
      urls.add(_baseUrl);
      tokens = [];
      tokens.add(_appToken);
      await ShpHelper.writeStringList(StorageKeys.base_url_list_key, urls);
      await ShpHelper.writeStringList(StorageKeys.app_tokens_list_key,tokens);
    }
  }
}
